/**
 *	shmsub.h  --  code definition for shmsub
 *		Kazuro Furukawa
 *
 *	K.Furukawa  Jun.8.1993. separated from smemsub.c
 *
 *	K.F, Aug.27.1997.  check _OSK and OSK
 *
 * @(#)shmsub.h v1.2.2  definition for shmsub, K.Furukawa, Jun.1993-Sep.1997.
 */

#ifndef __SHMSUB_H
#define __SHMSUB_H

#define CM_STRICT_SIZE				/* strict size */

#ifdef _OSK
#ifndef OSK
#define OSK
#endif
#endif

#ifndef OSK  /* for unix */
#ifndef unix
#define unix 1
#endif
#ifndef __SEMSUB_H
#include <sys/types.h>				/* types */
#include <sys/stat.h>				/* permissions */
#endif /* not __SEMSUB_H */
#endif /* not OSK */

#ifdef OSK
#include <module.h>				/* module header */
#endif /* OSK */

#ifdef CM_STRICT_SIZE				/* strict size recording */
#define CM_INTERN_HEAD	16			/* internal header size */
#else
#define CM_INTERN_HEAD	0
#endif /* CM_STRICT_SIZE */

/* error codes */

#define CM_SUCCESS	0		/* success */
#define CM_NOMEM	-1		/* no new memry available */
#define CM_OTHER	-2		/* other system call failure */
#define CM_EXIST	-3		/* shared memry existent */
#define CM_NOEXIST	-4		/* shared memry non existent */

/* error/information message codes */
/* currently no difference among OERR, OINFO, OALL */

#define CM_ONONE	0		/* no message */
#define CM_OERR		1		/* error message */
#define CM_OINFO	2		/* information message */
#define CM_OALL		3		/* all message */

/* permission codes */

#ifdef unix
#define CM_POWNER	(S_IRWXU|S_IRGRP)		/* owner+group read */
#define CM_PGROUP	(CM_POWNER|S_IRWXG|S_IROTH)	/* +world read */
#define CM_POTHER	(CM_PGROUP|S_IRWXO)		/* +world any */
#endif /* unix */

#ifdef OSK
#define CM_POWNER	(MP_OWNER_READ|MP_OWNER_WRITE|MP_OWNER_EXEC|\
			 MP_GROUP_READ)			/* owner+group read */
#define CM_PGROUP	(CM_POWNER|MP_GROUP_WRITE|MP_GROUP_EXEC|\
			 MP_WORLD_READ)			/* +world read */
#define CM_POTHER	(CM_PGROUP|MP_WORLD_WRITE|MP_WORLD_EXEC)
#endif /* OSK */					/* +world any */

#define CM_PWORLD	CM_POTHER
#define CM_PALL		CM_POTHER

/* globals */

extern void * cm_desc;			/* for cm_map and cm_unmap */
extern int cm_errno;			/* error number for cm_map */

/* functions */

int cm_check();				/* in smemsub.c */
int cm_info();
int cm_create();
void * cm_map();
void * cm_map_or_create();
int cm_unmap();
int cm_remove();

#endif /* __SHMSUB_H */
